<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

    <title>Output Formats</title>
    <meta name="description" content="ESTP 2023 course, day 3: Output Formats">
    <meta name="author" content="Ole Mussmann">

    <link rel="icon" type="image/x-icon" href="./files/favicon-32x32.png">

    <meta name="apple-mobile-web-app-capable" content="yes">
    <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">

    <meta name="viewport" content="width=device-width, initial-scale=1.0">

    <link rel="stylesheet" href="dist/reset.css">
    <link rel="stylesheet" href="dist/reveal.css">

    <!-- theme -->
    <link rel="stylesheet" href="dist/theme/black.css" id="theme">
    <link rel="stylesheet" href="dist/theme/escience_4.3.1.css" id="theme">

    <!-- fonts -->
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Nunito">
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Assistant">
    <link rel="stylesheet" href="https://fonts.googleapis.com/icon?family=Material+Icons">

    <!-- Theme used for syntax highlighted code -->
    <link rel="stylesheet" href="plugin/highlight/monokai.css">

    <!-- Load jQuery -->
    <script
      src="https://code.jquery.com/jquery-3.4.1.min.js"
      integrity="sha256-CSXorXvZcTkaix6Yvo6HppcZGetbYMGWSFlBw8HfCJo="
      crossorigin="anonymous"></script>
    <script src="http://localhost:35729/livereload.js"></script>

  </head>
  <body>
    <div class="reveal">
      <div class="slides">
        <section data-markdown data-state="blue_overlay 9 yellow_flag yellow_strip purple_half_circle_bottom purple_blob right_e_top" data-background-video="./files/473287184.mp4" data-background-video-loop data-background-video-muted="true">
<!-- https://www.videvo.net/video/purple-data-globe-concept/4815/ -->
<textarea data-template>

# Output Formats

<br>
<br>

<a href="mailto:o.mussmann@esciencecenter.nl">Ole Mussmann</a> | <a href="https://www.esciencecenter.nl/">eScience Center</a> | <img style="height: 2.5vw; padding: 0 .5vw; margin-bottom: -.5vw; margin-top: -2vw;" src="./files/eu_logo.png"><img style="height: 2vw; margin-bottom: -.5vw; margin-top: -2vw;" src="./files/logo_icon.jpg">

</textarea>
</section>
<section data-markdown data-state="standard" data-background="./files/checklist-2589418_1920.jpg">
<!-- https://pixabay.com/photos/checklist-goals-box-notebook-pen-2589418/ -->
<textarea data-template>

## Table of Contents

- [Data Serialization Languages](#/serial)
- [XML](#/xml)
- [JSON](#/json)
- [YAML](#/yaml)
- [Bonus: TOML](#/toml)
- [Parsing](#/parsing)
- [Summary](#/summary)
- [Links](#/links)

</textarea>
</section>

<section data-markdown data-state="yellow_flag logo black_overlay 5" data-background="./files/hammer-682767_1920.jpg">
<!-- https://pixabay.com/photos/hammer-sledgehammer-mallet-tool-682767/ -->
<textarea data-template>

# Data Serialization

<blockquote>
[...] Flatten object(s) into a one-dimensional stream of bits, and to turn that stream of bits back into the original object(s).
</blockquote>
<p style="padding-left: 40%;">- Marshall Cline</p>

Notes: Let's have the languages introduce themselves.


</textarea>
</section>

<section>
<section data-markdown data-state="yellow_flag logo purple_overlay" data-background="./files/xml_white.svg" data-background-size="contain" id="xml">
<textarea data-template>

# XML
## Extensible Markup Language

</textarea>
</section>

<section data-markdown data-state="yellow_flag logo purple_overlay" data-background="./files/xml_white.svg" data-background-size="contain" >
<textarea data-template>

## XML: The Veteran

<pre><code data-trim data-noescape><script type="text/template">
<?xml version="1.0" encoding="UTF-8" ?>
<xml>
    <introduced>1996</introduced>
    <standardized>yes</standardized>
    <comments>yes</comments> <!-- hi i'm a comment -->
    <verbosity>a lot!</verbosity>
    <readability>💩</readability>
    <parsability>easy</parsability>
    <complications>keep track of closing tags</complications>
    <features>namespaces</features>
    <features attribute="hi">attributes</features>
    <features>schema validation</features>
</xml>
</script></code></pre>

</textarea>
</section>
</section>

<section>
<section data-markdown data-state="yellow_flag logo blue_overlay" data-background="./files/json_white.svg" data-background-size="contain" id="json">
<textarea data-template>

# JSON
## JavaScript Object Notation

</textarea>
</section>

<section data-markdown data-state="yellow_flag logo purple_overlay" data-background="./files/xml_white.svg" data-background-size="contain" >
<textarea data-template>

## JSON: King of REST-APIs

<pre><code data-trim data-noescape>
{
  "json": {
    "introduced": 2001,
    "standardized": "yes",
    "comments": "no :(", // this comment invalidates JSON ⚠️
    "verbosity": "medium",
    "readability": "ok",
    "parsability": "easy",
    "complications": ["keep track of closing braces"],
    "features": [
      "syntax typing",
      {
      "_tag": "yes, but messy",
      "__text": "hack for tags"
      }
    ],
  }
}
</code></pre>

Notes: Syntax typing: infer type


</textarea>
</section>
</section>

<section>
<section data-markdown data-state="yellow_flag logo black_overlay" data-background="./files/yaml_white.svg" data-background-size="contain" id="yaml">
<textarea data-template>

# YAML
## YAML Ain't Markup Language
(yes, really)

</textarea>
</section>

<section data-markdown data-state="yellow_flag logo black_overlay" data-background="./files/yaml_white.svg" data-background-size="contain" >
<textarea data-template>

## YAML: Easy on the Eyes

<pre><code data-trim data-noescape>
yaml:
  introduced: 2001
  standardized: no formal standard
  comments: yes  # hi i'm a comment
  verbosity: low
  readability: good!
  parsability: can be messy
  complications:
    - flexibility can cause parsing hickups
  features:
    - schema dependent tags
</code></pre>

</textarea>
</section>

<section data-markdown data-state="yellow_flag logo black_overlay" data-background="./files/yaml_white.svg" data-background-size="contain" data-auto-animate >
<textarea data-template>

## YAML parsing

<pre><code data-trim data-noescape>
import yaml

data = """
countries:
  - FR
  - IT
  - NO
"""
</code></pre>

<pre class="fragment"><code data-trim data-noescape>
print(yaml.load(data, Loader=yaml.Loader))
</code></pre>

<pre class="fragment"><code data-trim data-noescape>
>>> {'countries': ['FR', 'IT', False]}
</code></pre>

<pre class="fragment"><code data-trim data-noescape>
print(yaml.load(data, Loader=yaml.BaseLoader))
</code></pre>

<pre class="fragment"><code data-trim data-noescape>
>>> {'countries': ['FR', 'IT', 'NO']}
</code></pre>

</textarea>
</section>
</section>

<section>
<section data-markdown data-state="yellow_flag logo white_overlay" data-background="./files/toml_white.svg" data-background-size="contain" id="toml">
<textarea data-template>

# Bonus: TOML
## Tom's Obvious, Minimal Language
(also yes, really)

</textarea>
</section>

<section data-markdown data-state="yellow_flag logo white_overlay" data-background="./files/yaml_white.svg" data-background-size="contain" >
<textarea data-template>

## TOML: Config File for Humans

<pre><code data-trim data-noescape>
[toml]
introduced = 2013-03-23T00:00:00-08:00  # proper dates
standardized = "no formal standard"
comments = "yes"  # hi i'm a comment
verbosity = "ok"
readability = "ok"
parsability = "ok"
complications = [ "hierarchies can be messy" ]
features = [ "simplicity", "syntax typing" ]

[hierarchies]
  [hierarchies.first_level]
  item = 1
  [hierarchies.second_level]
  item = "two"
</code></pre>

</textarea>
</section>
</section>

<section>
<section data-markdown data-state="logo yellow_flag white_overlay 9" data-background="./files/man-29749.svg" data-background-size="contain" id="parsing">
<!-- https://pixabay.com/vectors/man-looking-words-book-black-29749/ -->
<textarea data-template>

# Parsing

</textarea>
</section>

<section data-markdown data-state="logo yellow_flag white_overlay 9" data-background="./files/man-29749.svg" data-background-size="contain">
<textarea data-template>

## Reading and Writing

- Don't build your own parser!
- Python, R, Julia, etc. all have existing packages
- Also look out for helpers, e.g.
    - 🐍 LXML <a href="https://lxml.de">lxml.de</a>
        - XML validation
    - 🐍 YAtiML <a href="https://www.research-software.nl/software/yatiml">research-software.nl/software/yatiml</a>
        - YAML validation
        - Import/export directly from classes
        - Sane error handling

</textarea>
</section>
</section>

<section data-state="standard 4" data-background="./files/note-pad-1215425_1920.jpg" id="summary">
<!-- https://pixabay.com/illustrations/note-pad-pen-coffee-cup-plant-1215425/ -->

<div style="transform: rotate(-5deg); width: 72%; float: left; margin-left: 2vw;">
  <h2>Summary</h2>
  Different tools for different jobs
  <br>
  <br>
  <div style="text-align: left;">
    <b><code>&lt;/xml&gt; </code></b> safe, for/from machines
    <br>
    <br>
    <b><code>{json} </code></b> de-facto REST-API standard
    <br>
    <br>
    <b><code>- yaml </code></b> for humans
    <br>
    <br>
    <b><code>[toml] </code></b> niche, safer yaml
  </div>
</div>

</section>
<section data-markdown data-state="logo yellow_flag black_overlay" data-background="./files/earth-3537401_1920.jpg" id="links">
<!-- https://pixabay.com/illustrations/earth-network-blockchain-globe-3537401/ -->
<textarea data-template>

# Resources

<div style="font-size: x-large;">
  <ul>
    <li>Discussed</li>
    <ul>
      <li><a href="https://www.w3.org/XML">w3.org/XML</a></li>
      <li><a href="https://www.json.org">json.org</a></li>
      <li><a href="https://yaml.org">yaml.org</a></li>
      <li><a href="https://toml.io">toml.io</a></li>
    </ul>
    <li>2nd bonus: StrictYAML</li>
    <ul>
      <li><a href="https://hitchdev.com/strictyaml/">hitchdev.com/strictyaml</a></li>
    </ul>
    <li>Discussions</li>
    <ul>
      <li><a href="https://sandfox.me/misc/strictyaml-problems.html">sandfox.me/misc/strictyaml-problems.html</a></li>
      <li><a href="https://sandfox.me/misc/toml-yaml.html">sandfox.me/misc/toml-yaml.html</a></li>
      <li><a href="https://www.quora.com/What-situation-would-you-use-YAML-instead-of-JSON-or-XML">quora.com/What-situation-would-you-use-YAML-instead-of-JSON-or-XML</a></li>
      <li><a href="https://www.zionandzion.com/json-vs-xml-vs-toml-vs-cson-vs-yaml">zionandzion.com/json-vs-xml-vs-toml-vs-cson-vs-yaml</a></li>
    </ul>
  </ul>
</div>

</textarea>
</section>
      </div>
    </div>

    <script src="dist/reveal.js"></script>

    <script src="plugin/highlight/highlight.js"></script>
    <script src="plugin/markdown/markdown.js"></script>
    <script src="plugin/math/math.js"></script>
    <script src="plugin/notes/notes.js"></script>
    <script src="plugin/search/search.js"></script>
    <script src="plugin/zoom/zoom.js"></script>
    <!--
    <script src="reveal.js/4.3.1/reveal.js-plugins/menu/menu.js"></script>
    -->

    <script src="dist/escience.js"></script>

    <script>
      // More info about initialization & config:
      // - https://revealjs.com/initialization/
      // - https://revealjs.com/config/
      Reveal.initialize({
        hash: true,

        // Automatically activate the scroll view when we the viewport falls
        // below the given width.
        scrollActivationWidth: 0,  // disabled

        // Force the scrollbar to remain visible
        scrollProgress: true,

        // Learn about plugins: https://revealjs.com/plugins/
        plugins: [ RevealMarkdown, RevealHighlight, RevealNotes ]
      });
    </script>
  </body>
</html>
